

DECAL_POLYGON		EQU	04t
DECAL_HYDRO_LINE	EQU	08t
DECAL_STREAM_LINE	EQU	16t
DECAL_ROAD_LINE		EQU	32t



DECAL_HEADER	MACRO	mode, list, textures, end

	LOCAL	start
start	LABEL	WORD

	DD	14h	; length
	DD	mode
	DD	( OFFSET list ) - ( OFFSET start )
	DD	( OFFSET textures ) - ( OFFSET start )
	DD	( OFFSET end ) - ( OFFSET start )
	ENDM



DECAL_DATA	MACRO	count, rowOffset1, rowOffset2, colOffset, switch1, switch2, switch3

	DB	rowOffset2 * 40h + switch1 * 20h + switch2 * 10h + switch3 * 8h + count
	DB	colOffset * 8h + rowOffset1
	ENDM

DECAL_GEOMETRY	MACRO	count, type, tex1, tex2

	DB	type
	DB	tex1
	DB	tex2
	DB	count
	ENDM



DECAL_POINTS	MACRO	count

	DB	count
	ENDM



DECAL_POINT	MACRO	x, y

	DW	x
	DW	y
	ENDM



DECAL_LIST	MACRO	count, groups, data

	LOCAL	start
start	LABEL	WORD

	DD	10h	; length
	DD	count
	DD	( OFFSET groups ) - ( OFFSET start )
	DD	( OFFSET data ) - ( OFFSET start )
	ENDM



DECAL_GROUP	MACRO	row, column, start, data, end

	DD	( row * 400h + column ) * 1000h 
	DD	( OFFSET data ) - ( OFFSET start )
	DD	( OFFSET end ) - ( OFFSET data )
	ENDM



TEXTURE_HEADER	MACRO	count, groups, data, end

	LOCAL	start
start	LABEL	WORD

	DD	14h	; length
	DD	count
	DD	( OFFSET groups ) - ( OFFSET start )
	DD	( OFFSET data ) - ( OFFSET start )
	DD	( OFFSET end ) - ( OFFSET data )
	ENDM



TEXTURE_GROUP	MACRO start, data, end

	DD	( OFFSET data ) - ( OFFSET start )
	DD	( OFFSET end ) - ( OFFSET data )
	ENDM



TEXTURE_DATA	MACRO	number, unknown, type, size

	LOCAL	number_start, number_end

number_start	LABEL	BYTE

	DB	number

number_end 	LABEL	BYTE

IF	NOT ( ( OFFSET number_end ) - ( OFFSET number_start ) ) EQ 4
	%OUT	texture number has wrong length!
	.ERR
ENDIF

	DB	unknown
	DB	type
	DB	size
	ENDM



FLATTEN_HEADER	MACRO	mode, list, data, end

	LOCAL	start
start	LABEL	WORD

	DD	14h	; length
	DD	mode
	DD	( OFFSET list ) - ( OFFSET start )
	DD	( OFFSET data ) - ( OFFSET start )
	DD	( OFFSET end ) - ( OFFSET start )
	ENDM



FLATTEN_DATA	MACRO	count, rowOffset1, rowOffset2, colOffset, switch1, switch2, switch3

	DB	rowOffset2 * 40h + switch1 * 20h + switch2 * 10h + switch3 * 8h + count
	DB	colOffset * 8h + rowOffset1
	ENDM



FLATTEN_POLYGON	MACRO	count, height, scale

	IF count NE 0
		DB	count
	ENDIF

	DW	height
	DB	scale
	ENDM



FLATTEN_POINT	MACRO	x, y

	DB	x
	DB	y
	ENDM



FLATTEN_LIST	MACRO	count, groups

	LOCAL	start
start	LABEL	WORD

	DD	0Ch	; length
	DD	count
	DD	( OFFSET groups ) - ( OFFSET start )
	ENDM



FLATTEN_GROUP	MACRO	row, column, start, data, end

	DD	( row * 400h + column ) * 1000h + 0C00h
	DD	( OFFSET data ) - ( OFFSET start )
	DD	( OFFSET end ) - ( OFFSET data )
	ENDM
