include TMFmacros.inc	; Christian Stock's TMP Macros

; Macros - v 0.04 - G.Ioannu
UINT16		TYPEDEF 	WORD
UINT32		TYPEDEF 	DWORD
FLAGS16 	TYPEDEF 	WORD
FLAGS32 	TYPEDEF 	DWORD
BGLCODE		TYPEDEF		WORD

LIGHT_BEACON			EQU		0t
LIGHT_WING			EQU		1t
LIGHT_LOGO			EQU		2t
LIGHT_TAXI			EQU		3t
LIGHT_NAV			EQU		4t
LIGHT_LANDING			EQU		5t
LIGHT_STROBE			EQU		6t
LIGHT_RECOGNITION		EQU		7t
LIGHT_NONE			EQU		8t
LIGHT_LANDING_0 		EQU		9t
LIGHT_TAXI_0			EQU		10t
LIGHT_LANDING_1 		EQU		11t
LIGHT_TAXI_1			EQU		12t

GRG_FX2 macro fname, params,spc1, spc2
	local	start, name_start, name_end
start	label	word
	dw	0A0h
	dw	084h
	dw 	026Ch
	dw	0h
	dw	0h
name_start label byte
	db	fname,0
name_end label byte
	rept 80 - ((offset name_end) - (offset name_start))
	db 0
	endm
	db	params,0
	db	0
	endm




GRG_FX1   macro	effect_name, effect_params ; this is MS's macro
	local	effect_beg
	local	effect_end
	local	name_beg

effect_beg	label word
	dw	0A0h			; opcode
	dw	(offset effect_end) - (offset effect_beg)
	dw	OBJECTOP_EFFECT 	; type of object
	dd	0

name_beg label word
	db	effect_name
	db	(80 - ($-(offset name_beg))) dup (0)
	ifnb	<effect_params>
	ifdif	<effect_params>,<"">
	db	effect_params
	endif
	endif
	db	0
	db	($-(offset name_beg)) AND 1 dup (0)

effect_end	label word
	endm




GRG_WINDSOCK	macro	biasx,biasy,biasz,height,sock_length,pole_color,sock_color,flags
	dw		0A0h				; opcode
	dw		36				; total length of this opcode
	dw		OBJECTOP_WINDSOCK	; type of object (521)
	real4	biasx;				; bias from the current scale command in X (in scale units)
	real4	biasy;				; bias from the current scale command in Y (in scale units)
	real4	biasz;				; bias from the current scale command in Z (in scale units)
	real4	height;				; height of the support pole (in scale units)
	real4	sock_length;			; length of the sock (in scale units)
	UINT32	pole_color;			; RGBA color of the pole
	UINT32	sock_color;			; RGBA color of the sock
	FLAGS16	flags;				; general flags, all 0, bit 0 is lighted
	endm


GRG_ADDCAT	macro	dest, cat
	local	start
start  label word
	dw	74h
	dw	(offset dest)-(offset start)
	dw	cat
	endm

GRG_LIBRARY_CALL	macro	id1,id2,id3,id4		; calls a BGL library
	dw	063h				; opcode
	dw	0				; quick index lookup
	dd	id1,id2,id3,id4			; 4 guid128 values
	endm

;  Surface Types
CONCRETE	EQU		0t
GRASS_LANDABLE	EQU		1t
WATER		EQU		2t
GRASS_BUMPY	EQU		3t
ASPHALT		EQU		4t
GRASS_SHORT	EQU		5t
GRASS_LONG	EQU		6t
HARD_TURF	EQU		7t


GRG_LAKE_ST	macro	end_label,no_points,tex_code, alt, alt16
	local	start
start label word
	dw	0E6h				; opcode
	dd	(offset (end_label)) - (offset start)	; total length of this opcode
	dw	02
	dw	no_points
	dw	tex_code				; texture code
	dw	alt16					; altitude
	dw	alt					; altitude

endm

GRG_COAST_ST	macro	end_label,no_points,tex_code, alt, alt16
	local	start
start label word
	dw	0E6h				; opcode
	dd	(offset (end_label)) - (offset start)	; total length of this opcode
	dw	01
	dw	no_points
	dw	tex_code				; texture code
	dw	alt16					; altitude
	dw	alt					; altitude

endm